@echo off

echo Compiling AlbumE ...

mxmlc Albume.as -source-path core/classes -allow-source-path-overlap=true -default-frame-rate 50 -default-size 800 560

echo Compiling skins ...

cd skins/default
mxmlc box.as
mxmlc window_head.as
mxmlc window_body.as
mxmlc arrow_up.as
mxmlc arrow_down.as
mxmlc close.as
cd ../..

cd skins/kinetic
mxmlc button_up.as
mxmlc button_down.as
mxmlc window_head.as
mxmlc window_body.as
mxmlc arrow_up.as
mxmlc arrow_down.as
mxmlc button_close_up.as
mxmlc button_close_down.as
cd ../..

echo Compiling components ...

cd components/clock
mxmlc clock.as -source-path ../../core/classes -allow-source-path-overlap=true
cd ../..

cd components/info
mxmlc info.as -source-path ../../core/classes -allow-source-path-overlap=true
cd ../..

@echo on