package
 {
  import flash.display.Sprite;
  import flash.utils.Timer;
  import flash.events.TimerEvent;

  public class clock extends AR_Component
   {
    private var timer : Timer;
    private var date  : Date;
    private var l     : int;
    private var m     : int;
    private var _V    : Array = new Array(0x3f,0x14,0x6d,0x75,0x56,0x73,0x7b,0x15,0x7f,0x77);

    public function clock()
     {
      l = 160; m = 25;
      timer = new Timer(1000);
      timer.addEventListener(TimerEvent.TIMER, tick);
      timer.start();
	  super("clock",250*6+100*2,l*2+m*4);
     }

    public override function run() : void
	 {
      // Your code here (all the component parmeters are passed in _DATA object)
      date = new Date();
      drawClock();
     }

    private function drawClock() : void
     {
      var aux : String;

      // Background
	  graphics.lineStyle();
      graphics.beginFill(_DATA.bgcolor);
	  graphics.drawRect(0,0,width,height);
      graphics.endFill();
 
      if(date.getHours()  <10) aux =  "0"+date.getHours();
      else                     aux =  "" +date.getHours();
      if(date.getMinutes()<10) aux += "0"+date.getMinutes();
      else                     aux += "" +date.getMinutes();
      if(date.getSeconds()<10) aux += "0"+date.getSeconds();
      else                     aux += "" +date.getSeconds();
      drawDigit(aux.charCodeAt(0), 0);
      drawDigit(aux.charCodeAt(1), 250);
      drawColon(500+43);
      drawDigit(aux.charCodeAt(2), 500+100);
      drawDigit(aux.charCodeAt(3), 750+100);
      drawColon(1000+100+43);
      drawDigit(aux.charCodeAt(4), 1000+200);
      drawDigit(aux.charCodeAt(5), 1250+200);
	 }

    private function drawDigit(d : int, x : int) : void
     {
      d -= 48;
	  drawHLine(2*m+x,   m,       false);
      drawHLine(2*m+x,   m,       false);
      drawVLine(m+x,     2*m,     false);
      drawVLine(l+2*m+x, 2*m,     false);
      drawVLine(m+x,     l+3*m,   false);
      drawVLine(l+2*m+x, l+3*m,   false);
      drawHLine(2*m+x,   l*2+3*m, false);
      drawHLine(2*m+x,   l+2*m,   false);
      if(_V[d] & 0x01) drawHLine(2*m+x,   m);
      if(_V[d] & 0x02) drawVLine(m+x,     2*m);
      if(_V[d] & 0x04) drawVLine(l+2*m+x, 2*m);
      if(_V[d] & 0x08) drawVLine(m+x,     l+3*m);
      if(_V[d] & 0x10) drawVLine(l+2*m+x, l+3*m);
      if(_V[d] & 0x20) drawHLine(2*m+x,   l*2+3*m);
      if(_V[d] & 0x40) drawHLine(2*m+x,   l+2*m);
	 }

    private function drawHLine(x : int, y : int, is_on : Boolean = true) : void
     {
	  if(is_on) graphics.lineStyle(2*m,_DATA.on_color);
	  else      graphics.lineStyle(2*m,_DATA.off_color);
      graphics.moveTo(x,     y);
      graphics.lineTo(x+l-m, y);
	 }

    private function drawVLine(x : int, y : int, is_on : Boolean = true) : void
     {
	  if(is_on) graphics.lineStyle(2*m,_DATA.on_color);
	  else      graphics.lineStyle(2*m,_DATA.off_color);
      graphics.moveTo(x, y);
      graphics.lineTo(x, y+l-m);
	 }

    private function drawColon(x : int) : void
     {
      graphics.moveTo(x,m+(l>>1)  );
      graphics.lineTo(x,m+(l>>1)+1);
      graphics.moveTo(x,2*m+(l>>1)+l  );
      graphics.lineTo(x,2*m+(l>>1)+l+1);
	 }

    private function tick(event : TimerEvent) : void
     {
	  date = new Date();
      graphics.clear();
      drawClock();
     }
   }
 }
