package
 {
  import flash.display.Sprite;
  import flash.display.Loader;
  import flash.net.URLRequest;
  import flash.events.MouseEvent;
  import flash.events.ProgressEvent;

  public class AR_Thumbnail extends AR_Image
   {
	private var link   : String;
	private var target : AR_winImage;
	private var progr  : AR_Loader;

    public function AR_Thumbnail(url : String, lnk : String, trg : AR_winImage)
     {
      super(url,120,90);

      link   = lnk;
      target = trg;
      target.image.useHandCursor = true;
      addEventListener(MouseEvent.CLICK, click);

      loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, progress);

      progr = new AR_Loader();
      progr.x = (image_width  - progr.width) / 2;
      progr.y = (image_height - progr.height) / 2;
      if(url != "") addChild(progr);
     }

    private function click(event : MouseEvent) : void
     {
	  target.getDesktop().addChild(target);
	  target.progr.resetLoader();
	  target.image.loadImage(link);
	  target.addChild(target.progr);
	  target.setTitle("");// TODO image name...
     }

    private function progress(event : ProgressEvent) : void
     {
	  var p : int = (int)(event.bytesLoaded / event.bytesTotal * 100);
      progr.setPercentage(p);
      if(p >= 100) removeChild(progr);
     }
   }
 }
