package
 {
  import flash.events.MouseEvent;

  public class AR_winImagesList extends AR_Window
   {
	private var target         : AR_winImage;
	private var margin         : int;
	private var position       : int;
	private var visible_thumbs : int;
	private var thumb_width    : int;
	private var thumb_height   : int;
	private var _THUMBS        : Array = new Array();
	private var up             : AR_Button;
	private var down           : AR_Button;

    public function AR_winImagesList(dsk : AR_Desktop, skn : XML, tit : String, trg : AR_winImage, w : int, h : int)
     {
	  super(dsk,skn,tit,w,h);

      skin.up_icon   = skn.up_icon;
      skin.down_icon = skn.down_icon;
	  position       = 0;
	  visible_thumbs = 4;
	  margin         = 24 + body_top_margin;
	  target         = trg;
      thumb_width    = 120;
      thumb_height   = 90;

	  // Up button
	  up = new AR_Button(desktop,new XML(skin),skin.button_up_label,skin.button_up_icon,w,20,2);
	  up.x = body_left_margin; up.y = body_top_margin;
	  up.addEventListener(MouseEvent.CLICK, clickUp);
	  body.addChild(up);

	  // Down button
	  down = new AR_Button(desktop,new XML(skin),skin.button_down_label,skin.button_down_icon,w,20,3);
	  down.x = body_left_margin; down.y = h + body_top_margin - 20;
	  down.addEventListener(MouseEvent.CLICK, clickDown);
	  body.addChild(down);
     }

    public function addThumb(url : String, link : String) : void
	 {
      var l : int = _THUMBS.push(new AR_Thumbnail(url,link,target));
      body.addChild(_THUMBS[l-1]);
      moveThumbs();
	 }

    public function clearThumbs() : void
	 {
      var i : int;
      var l : int = _THUMBS.length;
      for(i = 0; i < l; i++)
       {
	    body.removeChild(_THUMBS[i]);
       }
      _THUMBS = new Array();
      position = 0;
	 }

    public function moveThumbs() : void
	 {
	  var i : int;
	  var n : int;
      for(i = 0; i < _THUMBS.length; i++)
       {
	    _THUMBS[i].y = 0;
        _THUMBS[i].x = 2000;
       }
      if(_THUMBS.length + position < visible_thumbs) n = _THUMBS.length + position;
      else                                           n = visible_thumbs + position;
      for(i = position; i < n; i++)
       {
	    _THUMBS[i].y = (i - position) * (thumb_height + 4) + margin;
        _THUMBS[i].x = body_left_margin;
       }
      //title.text = new String(position);
	 }

    private function clickUp(event : MouseEvent) : void
     {
      if(position > 0) position --;
      moveThumbs();
     }

    private function clickDown(event : MouseEvent) : void
     {
      if(position < _THUMBS.length - visible_thumbs) position ++;
      moveThumbs();
     }
   }
 }
