<?php

 // THIS FILE IS PART OF ALBUME
 // www.valarsoft.com

 defined('ALB_cEXEC') or die('Denied');

 class Util
  {

   function __construct() { }

   public static function quoteHTML($s,$only_quote = true)
    {//TODO è l'equivalante di htmlspecialchar($s,ENT_QUOTES)???
     // Parse $s before render it in a form field and replace:
     // '&' with '&amp;'
     // '"' with '&quot;'
     // '>' with '&gt;'
     // '<' with '&lt;'
  
     //(only_quote = false for textarea)
     //if($only_quote) return str_replace("\"","&quot;",$s);
     //else
  
      {
 	   $s = str_replace("&", "&amp;", $s);
  	   $s = str_replace("\"","&quot;",$s);
  	   $s = str_replace(">", "&gt;",  $s);
       $s = str_replace("<", "&lt;",  $s);
       return $s;
      }
    }

   public static function inputCheckbox($n,$v,$ck = '',$disabled = '', $extra ='')
    {
     //$v="Hquot($v); // TODO
     return "<input type=\"checkbox\" name=\"$n\" value=\"$v\" $ck $disabled $extra>";
    }

   public static function inputRadio($n,$v,$ck = "")
    {
     //$v="Hquot($v); // TODO
     return "<input type=\"radio\" name=\"$n\" value=\"$v\" $ck>";
    }

   public static function inputText($n,$v,$s = 60, $m = 255, $id = '', $js = '', $disabled = '')
    {
     $v = Util::quoteHTML($v);
     if(!$id) return "<input type=\"text\" name=\"$n\" value=\"$v\" size=\"$s\" maxlength=\"$m\" $js $disabled>";
     else     return "<input id=\"$id\" type=\"text\" name=\"$n\" value=\"$v\" size=\"$s\" maxlength=\"$m\" $js $disabled>";
    }

   public static function inputPassword($n,$v,$s = 60, $m = 255)
    {
     //$v="Hquot($v); // TODO
     return "<input type=\"password\" name=\"$n\" value=\"$v\" size=\"$s\" maxlength=\"$m\">";
    }

   public static function inputOption($n,$v,$s = "")
    {
     $n = Util::quoteHTML($n);
     return "<option value=\"$v\" $s>$n</option>";
    }

   public static function inputTextArea($n,$v,$r = 4,$c = 80, $extra = '')
    {
     $v = Util::quoteHTML($v); //TODO controllare funzione quoteHTML (lasciarla cosi'?)
     return "<textarea name=\"$n\" rows=\"$r\" cols=\"$c\" $extra>$v</textarea>";
    }

   public static function inputFile($n,$v,$s = 60)
    {
     //$v="Hquot($v); // TODO ???
     return "<input type=\"file\" size=\"$s\" name=\"$n\">";
    }

   public static function inputSubmit($n,$v, $id = '', $js = '', $disabled = '')
    {
     //$v = Util::quoteHTML($v);
     if(!$id) return "<input type=\"submit\" name=\"$n\" value=\"$v\" $js $disabled>";
     else     return "<input id=\"$id\" type=\"submit\" name=\"$n\" value=\"$v\" $js $disabled>";
    }

   public static function inputReset($n,$v, $id = '', $js = '', $disabled = '')
    {
     //$v = Util::quoteHTML($v);
     if(!$id) return "<input type=\"reset\" name=\"$n\" value=\"$v\" $js $disabled>";
     else     return "<input id=\"$id\" type=\"reset\" name=\"$n\" value=\"$v\" $js $disabled>";
    }

   public static function inputHidden($n,$v, $id = '', $js = '')
    {
     //$v = Util::quoteHTML($v);
     if(!$id) return "<input type=\"hidden\" name=\"$n\" value=\"$v\" $js>";
     else     return "<input id=\"$id\" type=\"hidden\" name=\"$n\" value=\"$v\" $js>";
    }

   public static function checkboxEnabled($n,$v,$disabled = '', $extra = '')
    {
     if($v) return Util::inputCheckbox($n,WM3_cENABLED,"checked",$disabled,$extra);
     else   return Util::inputCheckbox($n,WM3_cENABLED,"",$disabled,$extra);
    }

   public static function renderImg($file,$alt = '', $width = 24, $height = 24, $path = ALB_cPATH_CORE, $border = 0, $align = 'absmiddle')
    {
	 if($alt) $alt = "alt=\"$alt\" title=\"$alt\"";
	 return "<img src=\"".$path."$file\" width=\"$width\" height=\"$height\" border=\"$border\" align=\"$align\" $alt>";
	}

   public static function selectYesNo($w3,$n,$v)
    {
     // Make Yes/NO select
     return Util::selectArray($n,
                        array($w3->getWord(458),$w3->getWord(459)),
                        array(WM3_cYES,WM3_cNO),
                        $v);
    }

   public static function selectAlign($w3,$n,$v)
    {// TODO Se si usa solo per i panels, mettere in wm3Panel class ed usare WM3_cPANEL_LEFT al posto di WM3_cALIGN_LEFT eccetera
     // Make Left/Center/Right select
     return Util::selectArray($n,
                        array($w3->getWord(462),$w3->getWord(463),$w3->getWord(464)),
                        array(WM3_cALIGN_LEFT,WM3_cALIGN_CENTER,WM3_cALIGN_RIGHT),
                        $v);
    }

   public static function selectAlignImage($w3,$n,$v)
    {
     // Make Left//Right/No image select
     return Util::selectArray($n,
                        array($w3->getWord(462),$w3->getWord(464),$w3->getWord(592)),
                        array(WM3_cALIGN_LEFT,WM3_cALIGN_RIGHT,WM3_cNO_IMAGE),
                        $v);
    }

   public static function selectArray($n,$_L,$_V,$d,$js = "")
    {
     // Create a select from labels/values array with a default value $d
     $str = "<select $js name=\"$n\">";
     for($i = 0; $i < sizeof($_V); $i++)
      {
       if($_V[$i] == $d) $str .= Util::inputOption($_L[$i],$_V[$i],"selected");
       else              $str .= Util::inputOption($_L[$i],$_V[$i]);
      }
     $str .= "</select>";
     return $str;
    }

   public static function selectArrayEquals($n,$_V,$d,$js = 0,$path = "",$preview_image = "preview_image")
    {
     // Create a select with values/labels equals and a default value $d, labels/values are taked from $_V array
     // If js = 1 will create a select that use an image preview with images taken from $path folder
     if($js == 1) $str ="<select name=\"$n\" onChange=\"cambiaImg('$path','$preview_image',$n.value,'".WM3_cPATH_DATA."');\">";
     else $str ="<select name=\"$n\">";
     for($i = 0; $i < sizeof($_V); $i++)
      {
       if($d == $_V[$i]) $str .= "<option value=\"$_V[$i]\" selected>$_V[$i]</option>";
       else              $str .= "<option value=\"$_V[$i]\">$_V[$i]</option>";
      }
     $str .= "</select>";
     return $str;
    }

   public static function selectDirectory($path,$name,$d,$js = false,$dir_only = false,$preview_image = 'preview_image')
    {
     // Create a select from a directory $path files list with a default value $d
     // If js = 1 will create a select that use an image preview with images taken from $path folder
     $fd = opendir($path); $i = 0;
     while(($file = readdir($fd)))
      {
       if($file != "." && $file != ".." && $file != "index.html") // Do not render ".", ".." and index.html
        {
		 if($dir_only)
		  {
		   if(is_dir($path.$file))
		    {
			 $_FILENAMES[$i] = $file;
             $i++;
	        }
		  }
		 else
		  {
		   if(!is_dir($path.$file))
		    {
			 $_FILENAMES[$i] = $file;
             $i++;
	        }
	      }
        }
      }
     closedir($fd);
     if(isset($_FILENAMES))
      {
       sort($_FILENAMES);
       if($js == 1) return Util::selectArrayEquals($name,$_FILENAMES,$d,$js,$path,$preview_image);
       else         return Util::selectArrayEquals($name,$_FILENAMES,$d);
      }
    }

   public static function actionButton($link,$img,$alt,$accept = "",$text = "",$border = 0,$w = 24, $h = 24, $align = "absmiddle",$target = "_self")
    {
     // Create an action button
     if($text) $text = " ".$text; 
     if($accept) $str = "<a href=\"$link\" target=\"$target\" onclick=\"return wm3_accept('$accept');\">"; else $str = "<a href=\"$link\" target=\"$target\">";
	 $str .= Util::renderImg($img,$alt,$w,$h,WM3_cPATH_DATA,$border,$align)."$text</a>";
     return $str;
    }

   public static function helpButton($file,$help,$alt = '???', $width = 16, $height = 16, $path = WM3_cPATH_DATA, $border = 0, $align = 'absmiddle')
    {
	 if($alt) $alt = "alt=\"$alt\" title=\"$alt\"";
	 return "<img src=\"".$path."$file\" width=\"$width\" height=\"$height\" border=\"$border\" align=\"$align\" $alt onclick=\"return alert('$help');\">";
	}

   public static function renderDate($w3,$ts,$languageID,$full = true,$msg = '',$time = true,$day = false)
    {
     if($msg) if($ts == 0) return $msg; // If $ts its 0 return msg if not empty
     if($full) $m = $w3->getWordMonth(date("n",$ts)); else $m = date("m",$ts);
	 if($time) $t = date(" (H:i:s)",$ts); else $t = "";
	 if($day)  $d = $w3->getWordDayOfTheWeek(date("N",$ts)).", "; else $d = "";
     if($languageID == WM3_cLANGUAGE_EN) return $d.$m.date(" d Y",$ts).$t;              // English language
     else                                return $d.date("d ",$ts).$m.date(" Y",$ts).$t; // Other language
    }

   public static function getFirstFile($path)
    {
     // Get the first file in a $path (do not return ".", ".." and index.html)
     $fd = opendir($path);
     while(($file = readdir($fd)))
      if($file != "." && $file != ".." && $file != "index.html") return $file;
    }

   public static function generatePassword()
    {
     // Generate a random alphanumeric password
	 $ts = time().rand(1,99999);
	 return substr(md5($ts), rand(0,24), 8);
    }

   public static function isInteger($num)
    {
     return @eregi("^[0-9]*$",$num);
    }

   public static function isEmail($email)
    {
     return @eregi("^[a-z0-9][_\.a-z0-9-]+@([a-z0-9][0-9a-z-]+\.)+([a-z]{2,4})$",$email);
    }

   public static function isLogin($login)
    {
	 // Return true if $login is 3-16 characters long and have only numbers, letters and '_'
     return @eregi("^[[:alnum:]\.\_]{3,16}$",$login);
	}
 
   public static function isUrl($url)
    {
	 // Return true if $url its an absolute url
     return @eregi("^(https?://){1}(([0-9a-z_!~*'().&=+$%-]+: )?[0-9a-z_!~*'().&=+$%-]+@)?(([0-9]{1,3}\.){3}[0-9]{1,3}|([0-9a-z_!~*'()-]+\.)*([0-9a-z][0-9a-z-]{0,61})?[0-9a-z]\.[a-z]{2,6})(:[0-9]{1,4})?((/?)|(/[0-9a-z_!~*'().;?:@&=+$,%#-]+)+/?)$",$url);
    } 
 
   public static function isUrlRelative($url)
    {
     // Return true if $url its a relative url/path
     return @eregi("^(((/{1}\.{1})?[a-zA-Z0-9_!~*'().;?:@&=+$,%#-]+/?)+(\.{1}[a-zA-Z0-9]{2,4})?)$",$url);
    }

   public static function isImageUrl($url)
    {
     // Return true if $url its an absolute url to an image file
     return @eregi("^(http\://[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(?:/\S*)?(?:[a-zA-Z0-9_])+(.[jJ][pP][gG]|.[jJ][pP][eE][gG]|.[gG][iI][fF]|.[pP][nN][gG]))$",$url);
    }

   public static function isImageUrlRelative($url)
    {
     // Return true if $url its a relative url/path to an image file
     return @eregi("^(((\.\.){1}/)*|(/){1})?(([a-zA-Z0-9]*)/)*([a-zA-Z0-9]*)+(.[jJ][pP][gG]|.[jJ][pP][eE][gG]|.[gG][iI][fF]|.[pP][nN][gG])+$",$url);
    }

   public static function isFolderWritable($path)
    {
	 // Check if a folder its writable
     if(@touch($path."/wm3_temp.tmp")) // Use touch for compatibility with windows servers based
	  {
       @unlink($path."/wm3_temp.tmp");
	   return true;
      }
	 else return false;
	}

   public static function getFileExists($first_file,$second_file)
    {
     // Return first file if exists else return the second file
     if(file_exists($first_file)) return $first_file;
     else                         return $second_file;
	}

   public static function checkExtension($file,$ext)
    {
     // Verify if a file have $ext extension
     $e = Util::cutExtension($file);
     foreach($ext as $v) if(strtoupper($v) == strtoupper($e)) return 1;
     return 0;
    }

   public static function cutExtension($file)
    {
     // Return the extension of a filename
     $len = strlen($file);
     if($len == 0) return "";
     for($i = $len - 1; $i >= 0; $i--)
      {
       if($file[$i] == ".") return substr($file,$i+1,strlen($file));
      }
     return "";
    }

   public static function parseSearchFilter()
    {
     // Parse the search filter to avoid illecit search

     // By post
     if(isset($_POST['filter_check'])) $_POST['filter_check'] = intval($_POST['filter_check']);
     if(isset($_POST['filter']))
      {
       $_POST['filter'] = trim(str_replace(array('%','\''),'',$_POST['filter']));
       if(strlen($_POST['filter']) < 3) { $_POST['filter'] = ""; $_POST['filter_check'] = ""; }
      }

     // By get
     if(isset($_GET['filter_check'])) $_GET['filter_check'] = intval($_GET['filter_check']);
     if(isset($_GET['filter']))
      {
	   $_GET['filter'] = trim(str_replace(array('%','\''),'',$_GET['filter']));
       if(strlen($_GET['filter']) < 3) { $_GET['filter'] = ""; $_GET['filter_check'] = ""; }
      }
    }
 
   public static function stripMagicQuotes()
    {
     // Dequote all the variables (override magic_quotes_gpc option, works like magic_quotes_gpc as set to Off)
     if(get_magic_quotes_gpc())
      {
	   reset($_POST);
	   reset($_GET);
	   reset($_COOKIE);
       $_POST   = array_map('stripslashes_deep',$_POST);
       $_GET    = array_map('stripslashes_deep',$_GET);
       $_COOKIE = array_map('stripslashes_deep',$_COOKIE);
       for($i = 0; $i < sizeof($_POST); $i++)
        {
         $nvar = key($_POST);
         global $$nvar;
         $$nvar = stripslashes($$nvar);
         next($_POST);
        }
       for($i = 0; $i < sizeof($_GET); $i++)
        {
         $nvar = key($_GET);
         global $$nvar;
         $$nvar = stripslashes($$nvar);
         next($_GET);
        }
       for($i = 0; $i < sizeof($_COOKIE); $i++)
        {
         $nvar = key($_COOKIE);
         global $$nvar;
         $$nvar = stripslashes($$nvar);
         next($_COOKIE);
        }
      }
    }

   public static function microtimeFloat()
    {
     // Return microtime converted to float
     list($usec,$sec) = explode(" ", microtime());
     return ((float)$usec + (float)$sec);
    }

   public static function delayTime()
    {
     // Return page generator time in seconds 	
     $end_time = Util::microtimeFloat();
     return round(($end_time - WM3_cSTART_TIME),5);
    }

   public static function quoteDB($str)
    {
     // Quote / and ' before send data into the database
     //if(!anyUserLogged(1)) $str = htmlspecialchars($str,ENT_NOQUOTES); // If not admin logged, remove all html tags
     $str = str_replace("\\" ,"\\\\", $str);
     $str = str_replace("'",  "\'",   $str);
     return $str;
    }

   public static function unquoteDB($str)
    {
     //TODO forse è inutile
     // Remove quote from / and ' after take data from database
     $str = str_replace("\'",  "'",   $str);
     $str = str_replace("\\\\","\\" , $str); 
     return $str;
    }
   
   public static function getPhpInformations($fl = INFO_ALL)
    {
     ob_start();
     phpinfo($fl);
     $php_info = ob_get_contents();
	 $php_info = str_replace( "module_Zend Optimizer","module_Zend_Optimizer",preg_replace( '%^.*<body>(.*)</body>.*$%ms','$1',$php_info));
	 ob_end_clean();
     $php_info .="<style type=\"text/css\">
                   .center { text-align: left; }
                   .p      { text-align: left;}
                   .e      { background-color: #ccccff; font-weight: bold; color: #000000; }
                   .h      { background-color: #9999cc; font-weight: bold; color: #000000; }
                   .v      { background-color: #cccccc; color: #000000;}
                   .vr     { background-color: #cccccc; text-align: right; color: #000000; }
                  </style>";
	 return $php_info;
    }

   public static function dieMessage($label,$msg)
    {
     $str = "<html><body>
	          <table width=\"80%\" border=\"1\" align=\"center\"><tr><td bgcolor=\"#ff2222\"><b>$label:</b></td></tr>
               <tr><td bgcolor=\"#ffffff\">$msg</td></tr>
              </table>
			 </body></html>";
     die($str);
    }

   public static function message($msg,$p = 0)
    {
	 switch($p)
	  {
	   case 0: { $col = '#dddddd'; break; }
	   case 1: { $col = '#eeeeee'; break; }
	   case 2: { $col = '#ff9999'; break; }
      }
     $str = "<tr bgcolor=\"$col\"><td>$msg</td></tr>";
     return $str;
    }

   public static function getVariable($name,$method)
    {
     if($method == "get")  if(isset($_GET [$name])) return $_GET [$name];
     if($method == "post") if(isset($_POST[$name])) return $_POST[$name];
     if($method == "both")
      {
       if(isset($_GET [$name])) return $_GET [$name];
       if(isset($_POST[$name])) return $_POST[$name];
      }
   	}

   public static function getPostValueArray($_FIELD)
    {
     // Get all the post variables value needed and put it into the fields array
	 $_AUX = array();
     for($i = 0; $i < sizeof($_FIELD); $i++)
      {
       $_AUX[$_FIELD[$i]] = Util::getVariable($_FIELD[$i],'post');
      }
     return $_AUX;
    }

   public static function getColorArray($_FIELD)
    {
     // Set correct color to a form fields
	 $_AUX = array();
     for($i = 0; $i < sizeof($_FIELD); $i++)
      {
       if($i%2 == 0) $_AUX[$_FIELD[$i]] = '#dddddd';
       else          $_AUX[$_FIELD[$i]] = '#eeeeee';
      }
     return $_AUX;
    }

  }

?>
