package
 {
  import flash.display.Sprite;
  import flash.display.Loader;
  import flash.net.URLRequest;
  import flash.utils.Timer;
  import flash.events.Event;
  import flash.events.TimerEvent;

  public class AR_Image extends Sprite
   {
    public    var loader       : Loader;
    private   var timer        : Timer;
    protected var image_width  : int;
    protected var image_height : int;
    protected var resize       : Boolean;

    public function AR_Image(url : String, w : int, h : int, r : Boolean = true)
     {
      image_width  = w;
      image_height = h;
      resize = r;

      timer = new Timer(50);
      timer.addEventListener(TimerEvent.TIMER, fx);

      loader = new Loader();
      loader.contentLoaderInfo.addEventListener(Event.COMPLETE, complete);
      if(url != "") loadImage(url);
      addChild(loader);
     }

    public function loadImage(url : String) : void
     {
      loader.load(new URLRequest(url));
     }

    private function complete(event : Event) : void
     {
	  loader.alpha = 0.0;
	  if(resize)
	   {
        width  = image_width;
        height = image_height;
	   }
      timer.start();
     }

    private function fx(event : TimerEvent) : void
     {
      loader.alpha += 0.2;
      if(loader.alpha >= 1.0) { timer.stop(); loader.alpha = 1.0; }
     }
   }
 }
