package
 {
  import flash.display.Sprite;
  import flash.utils.Timer;
  import flash.events.TimerEvent;

  public class AR_Loader extends Sprite
   {
    private var timer : Timer;

    private var image_width  : int;
    private var image_height : int;
    private var percentage   : int;

    public function AR_Loader()
     {
	  graphics.lineStyle(1, 0xffffff);
	  graphics.drawRect(0, 0, 104, 8);
	  
	  percentage = 0;

      timer = new Timer(50);
      timer.addEventListener(TimerEvent.TIMER, anim);
      timer.start();
      //addChild(loader);
     }

    public function resetLoader() : void
     {
      percentage = 0;
      timer.start();
	 }

    public function setPercentage(p : int) : void
     {
      percentage = p;
	 }

    private function anim(event : TimerEvent) : void
     {
      graphics.clear();
	  graphics.lineStyle(1, 0xffffff);
	  graphics.drawRect(0, 0, 104, 8);
	  graphics.lineStyle(1, 0x666666);
	  graphics.beginFill(0xffffff);
	  graphics.drawRect(2, 2, percentage, 4);
	  graphics.endFill();
      if(percentage == 100) timer.stop();
     }
   }
 }
